Attribute VB_Name = "Module1"
Option Explicit

Declare Function GetBitmapBits Lib "gdi32" (ByVal hBitmap As Long, ByVal dwCount As Long, lpBits As Any) As Long
Declare Function SetBitmapBits Lib "gdi32" (ByVal hBitmap As Long, ByVal dwCount As Long, lpBits As Any) As Long
Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type
' *********************************************
' Rotate fr_pic 90 degrees and place the result
' in to_pic. Both PictureBoxes should have
' AutoRedraw = True.
' *********************************************
Public Sub RotatePicture(fr_pic As PictureBox, to_pic As PictureBox)
Dim bm As BITMAP
Dim hbm As Long
Dim fr_bytes() As Byte
Dim to_bytes() As Byte
Dim fr_wid As Long
Dim fr_hgt As Long
Dim to_wid As Long
Dim to_hgt As Long
Dim X As Integer
Dim Y As Integer

    ' Make to_pic use fr_pic's color palette.
    to_pic.Picture = fr_pic.Picture
    
    ' Get fr_pic's pixels.
    hbm = fr_pic.Image
    GetObject hbm, Len(bm), bm
    fr_wid = bm.bmWidthBytes
    fr_hgt = bm.bmHeight
    ReDim fr_bytes(1 To fr_wid, 1 To fr_hgt)
    GetBitmapBits hbm, fr_wid * fr_hgt, fr_bytes(1, 1)
    
    ' Bitmap widths must be even.
    to_hgt = fr_wid
    to_wid = fr_hgt
    If to_wid Mod 2 = 1 Then to_wid = to_wid + 1
    
    ' Make room for to_pic's pixels.
    ReDim to_bytes(1 To to_wid, 1 To to_hgt)
    
    ' Make to_pic the right size.
    to_pic.Width = to_pic.Parent.ScaleX(fr_hgt, vbPixels, to_pic.Parent.ScaleMode) + _
        to_pic.Width - to_pic.ScaleWidth
    to_pic.Height = to_pic.Parent.ScaleY(fr_wid, vbPixels, to_pic.Parent.ScaleMode) + _
        to_pic.Height - to_pic.ScaleHeight
    
    ' Copy the pixels.
    For X = 1 To fr_wid
        For Y = 1 To fr_hgt
            to_bytes(fr_hgt - Y + 1, X) = fr_bytes(X, Y)
        Next Y
    Next X
    
    ' Set the pixels in to_pic.
    SetBitmapBits to_pic.Image, _
        fr_hgt * fr_wid, to_bytes(1, 1)
    to_pic.Refresh

    ' Make the image permanent.
    to_pic.Picture = to_pic.Image
End Sub
